;
; Funciones para poner hang  y echo a off en GNU Clisp
;
; Clisp terminal interaction:
; http://www.gnu.org/software/clisp/impnotes/terminal.html
; http://cvs.sourceforge.net/viewcvs.py/clisp/clisp/src/keyboard.lisp


(defvar mode nil)

(defun echo-hang-off ()
  (setf echo-hang nil)
  (unwind-protect
      (unless EXT:*keyboard-input*
	(setq EXT:*keyboard-input* (sys::make-keyboard-stream)))
    (setq mode (sys::terminal-raw *terminal-io* t))))

(defun restore-echo-hang ()
  (setf echo-hang t)
  (unwind-protect
      (setq mode (sys::terminal-raw *terminal-io* mode))))

(defvar last-read-char nil)

(defun read-char-no-hang-no-echo (&optional (stream EXT:*keyboard-input*))
  "Lee una pulsación de tecla si se ha producido. Solo clisp."
  (if last-read-char
      (prog1
	  last-read-char
	(setf last-read-char nil))
    (let ((key (read-char-no-hang stream)))
      (if key
	  (system::input-character-char key)))))

;(defun read-char-no-hang-no-echo (&optional (stream EXT:*keyboard-input*))
;  "Lee una pulsación de tecla si se ha producido. Solo clisp."
;  (if (listen EXT:*keyboard-input*)
;   (let ((key (read-char EXT:*keyboard-input*)))
;     (if key
;	 (system::input-character-char key)))))

(defun unread-char-no-hang-no-echo (char &optional (stream EXT:*keyboard-input*))
  (setf last-read-char char))

