;; -------------------------------
;; Presentacin de entorno PlanTron
;; --------------------------------
;;  Este fichero recoge una serie de instrucciones
;;  que guan el aprendizaje del entorno de agentes
;;  PlanTron (ver fichero README).
;;
;;  Puedes ir copiando sobre una consola las
;;  instrucciones aqu descritas.
;;


;; Para cargar el entorno
;; ----------------------

;; Arrancamos en consola el CMUCL lisp con 'cmucl'
#|

cmucl

|#


;; Cargamos el entorno en el lugar en que est,
;; en el CC de la ETSII se encuentra en el
;; directorio /scratch/plantron
;;

(load "/scratch/plantron/pt-loader")



;; Partida con humano
;; ------------------

;; Movimientos de teclas:
;;   8: arriba, 2:abajo, 6: derecha, 4:izquierda

(pt:partida)


; Descripcin de funciones y variables

(describe 'pt:partida)


; Informacin del agente

(pt::info-jug "AGENTE-HUMANO")



;; Partida con agente mitad
;; ------------------------

(pt:partida "AGENTE-MITAD")

;; Ms rpido, opcin :sleep-cs

(pt:partida "AGENTE-MITAD" :sleep-cs 1)


;; Generar plantas solo en casillas vacas

(setf pt-agentes-genpla:*plantar-sobre-rastro* nil)

(pt:partida "AGENTE-MITAD" :sleep-cs 1)


;; Partidas con ms plantas iniciales

(setf pt-agentes-genpla:*ratio-plantas* 0.25)

(describe 'pt-agentes-genpla:*ratio-plantas*)

(pt:partida "AGENTE-MITAD" :sleep-cs 1)



;;
;; Consultar jugadores disponibles
;; -------------------------------

(pt:jug)

(describe 'pt:jug)

(pt:jug :full t)



;; Partida con agente espiral
;; --------------------------

(pt:partida "AGENTE-ESPIRAL" :sleep-cs 1)


;; Generar plantas tambin sobre rastro

(setf pt-agentes-genpla:*plantar-sobre-rastro* t)

(describe 'pt-agentes-genpla:*plantar-sobre-rastro*)

(pt:partida "AGENTE-ESPIRAL" :sleep-cs 5)



;; Partida con agente temerario
;; ----------------------------

(pt:partida "AGENTE-TEMERARIO" :sleep-cs 1)



;; Partida con agente hormiga borracha
;; -----------------------------------

(pt:partida "AGENTE-HORMIGA-BORRACHA" :sleep-cs 10)



;; Partidas con dos agentes
;; ------------------------

(setf pt-agentes-genpla:*plantar-sobre-rastro* nil)


(pt:partida "AGENTE-MITAD" "AGENTE-ESPIRAL" :sleep-cs 1)


(pt:partida "AGENTE-MITAD" "AGENTE-IMITADOR" :sleep-cs 1)


(pt:partida "AGENTE-ESPIRAL" "AGENTE-IMITADOR" :sleep-cs 1)


(pt:partida "AGENTE-HORMIGA-BORRACHA" "AGENTE-IMITADOR" :sleep-cs 1)


(pt:partida "AGENTE-ESPIRAL" "AGENTE-HUMANO")



;; Partida con trazas de cosultas, opcin :vis
;; -------------------------------------------

(setf pt-agentes-genpla:*plantar-sobre-rastro* nil)

(pt:partida "AGENTE-ESPIRAL" :sleep-cs 5 :vis 2)

(pt:partida "AGENTE-ESPIRAL" :sleep-cs 1 :vis 2)



;; Partida con generador de plantas aleatorio, opcin :genpla
;; ----------------------------------------------------------

(pt:partida "AGENTE-ESPIRAL" :sleep-cs 1 :genpla 0 :vis 2)



;; Cargar y ejecutar un nuevo agente
;; ---------------------------------

(pt:load-ag "agentes-aluXXXX.lisp")

(pt:jug)

(pt:partida "ALUXXXX-MITAD" :sleep-cs 1)



;; Pintar el tablero en otra terminal, opcin :dev-vis
;; ---------------------------------------------------

; Localizar antes con 'w' el dispositivo asociado
; a una terminal existente, por ejemplo "/dev/pts/3"

(pt:partida "AGENTE-ESPIRAL" :sleep-cs 1 :dev-vis "/dev/pts/3")



;; Partidas paso a paso
;; --------------------

(setf pt-vis:*step* t)

(pt:partida "AGENTE-ESPIRAL" :vis 2 :dev-vis "/dev/pts/3")

(describe 'pt-vis:*step*)



;; Partidas de todos los agentes no interactivos
;; ---------------------------------------------

(pt:partida-todos :sleep-cs 5)

(describe 'pt:partida-todos)



;; Trabajo con repositorio arena
;; -----------------------------

; Mostrar los agentes en repositorio arena

(pt-arena:ls)

(describe 'pt-arena:ls)

(pt-arena:ls "*" t)


; Chequear y enviar agentes al repositorio arena

(pt-arena:send "agentes-aluXXXX.lisp")


; Cargar agente del repositorio arena

(pt-arena:load-ag "agentes-aluXXXX")


; Tablas de resultados

(pt-arena:hof)

(describe 'pt-arena:hof)



;; Ejemplo de agentes buscadores de caminos
;; ----------------------------------------

; Cargar agentes de caminos del repositorio arena

(pt-arena:load-ag "agentes-aluXXXX-camino")

(describe 'pt-arena:load-ag)


; Lanzar agente bsqueda de camino en anchura

(pt:partida "ALUXXXX-CAMINO-BA")

(setf pt-agentes-genpla:*ratio-plantas* 0.05)

(pt:partida "ALUXXXX-CAMINO-BA" :vis 2)


; Lanzar agente bsqueda de camino en A*

(pt:partida "ALUXXXX-CAMINO-A" :vis 2)

(pt:partida "ALUXXXX-CAMINO-A" :vis 2 :sleep-cs 60)



;; Salir del cmucl lisp
;; --------------------

(quit)
